
/******************************************************************************
* MODULE     : keyw_begin.cc
* DESCRIPTION: Sequences of instructions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::evaluate_begin_1 () {
  // INPUT: (begin_1, cont, ...)
  list l= cdr (as_list (car (trace)));
  if (nil (l)) {
    cur= car (rem);
    rem= cons (VAL_NONE, cdr (rem));
    // OUTPUT: (cont, void, ...)
    trace= cdr (trace);
  }
  else {
    cur= car (l);
    rem= cons (KW_BEGIN_2, cdr (l), rem);
    // OUTPUT: (first_instr, begin_2, other_instrs, cont, ...)
  }
}

void
evaluator_rep::evaluate_begin_2 () {
  // INPUT: (begin_2, first_res, other_instrs, cont, ...)
  list l= as_list (cadr (rem));
  if (nil (l)) {
    cur= caddr (rem);
    rem= cons (car (rem), cdddr(rem));
    // OUTPUT: (cont, res, ...)
    trace= cdr (trace);
  }
  else {
    cur= car (l);
    rem= cons (KW_BEGIN_2, cdr (l), cddr (rem));
    // OUTPUT: (next_instr, begin_2, other_instrs, cont, ...)
  }
}

} // namespace mmx
