
/******************************************************************************
* MODULE     : keyw_function.cc
* DESCRIPTION: Evaluation of function types
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::evaluate_function_1 () {
  generic dom= car (trace)[1];
  generic im = car (trace)[2];
  if (is_func (dom, MMX_TUPLE))
    dom= cons (symbol ("Cross", car (dom)), cdr (as_list (dom)));
  if (is_func (im, MMX_TUPLE))
    im= cons (symbol ("Cross", car (im)), cdr (as_list (im)));
  evaluate_args (list (dom, im), KW_FUNCTION_2);
}

void
evaluator_rep::evaluate_function_2 () {
  // INPUT: (function_2, (dom, im), cont, ...)
  list  l  = as_list (car (rem));
  value dom= as_value (car (l));
  value im = as_value (cadr (l));
  if (dom->type != ID_CLASS)
    error (car (trace) [0], "Not a type");
  else if (im->type != ID_CLASS)
    error (car (trace) [1], "Not a type");
  else {
    value res (list (ID_FUNCTION, dom->val, im->val), ID_CLASS);
    cur= cadr (rem);
    rem= cons (res, cddr (rem));
    // OUTPUT: (cont, func_type, ...)
    trace= cdr (trace);
  }
}

} // namespace mmx
