
/******************************************************************************
* MODULE     : keyw_lambda.cc
* DESCRIPTION: The 'lambda' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

list
flatten_vars (list l) {
  if (nil (l)) return l;
  if (is_func (car (l), MMX_TYPE, 2))
    return cons (car (l) [1], flatten_types (cdr (l)));
  return cons (car (l), flatten_types (cdr (l)));
}

list
flatten_types (list l) {
  if (nil (l)) return l;
  if (is_func (car (l), MMX_TYPE, 2))
    return cons (car (l) [2], flatten_types (cdr (l)));
  return cons (car (l), flatten_types (cdr (l)));
}

void
evaluator_rep::evaluate_lambda_1 () {
  // INPUT: (lambda_1, cont, ...)
  generic g   = car (trace);
  generic dom = cons (MMX_CROSS, flatten_types (as_list (g[1])));
  generic type= list (MMX_FUNCTION, dom, g[2]);
  evaluate_arg (type, KW_LAMBDA_2);
}

void
evaluator_rep::evaluate_lambda_2 () {
  // INPUT: (lambda_2, type, cont, ...)
  value type= as_value (car (rem));
  if (type->type != ID_CLASS) {
    error (car (trace), "Lambda expression has no type");
    return;
  }
  generic g= car (trace);
  list vars= flatten_vars (as_list (g[1]));
  list ltypes;
  if (is_list (type->val[1])) ltypes= cdr (as_list (type->val[1]));
  list lamb (car (g), env, vars, ltypes, type->val[2], g[3]);
  cur= cadr (rem);
  rem= cons (value (lamb, type->val), cddr (rem));
  // OUTPUT: (cont, typed_lambda_expr, ...)
  trace= cdr (trace);
}

} // namespace mmx
