
template<typename R> inline
mm_obj<R>
as_mm_obj (generic g)
{
  if (gentype(g) != mm_rep<R>::TYPE)
    fatal_error ("generic is not an mm_obj of required type",
		 "as_mm_obj", "mm_upoly.hh");
  return mm_obj<R> ((mm_rep<R>*)g.rep); 
}

/******************************************************************************
* Required mm_ints for generic structures
******************************************************************************/

template<typename R>
int
mm_rep<R>::Type () {
  return TYPE;
}

//template<typename R> int mm_rep<R>::Hash () {return 1;}

template<typename R>
bool
mm_rep<R>::Equal (generic g) {
  if (gentype (g) != mm_rep<R>::TYPE) return FALSE;
  return mm_obj<R> (this) == as_mm_obj<R> (g);
}

template<typename R>
generic
mm_rep<R>::Copy () {
  return copy (mm_obj<R> (this));
}

template<typename R>
int
mm_rep<R>::Arity () {
  return 0;
}

template<typename R>
void
mm_rep<R>::Print (std::ostream& out) {
  out << mm_obj<R> (this);
}

/****************************************************************************
* Routines for mm_obj
****************************************************************************/

template<typename R>
std::ostream&
operator << (std::ostream& out, mm_obj<R> x) {
  return out << x->data;
}

template<typename R>
mm_obj<R>
copy (mm_obj<R>  x)  {
  return mm_obj<R> (x->data);
}
