
/******************************************************************************
* MODULE     : types.cc
* DESCRIPTION: frequently used type symbols and values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <token_symbols.hh>
#include <types.hh>
#include <list.hh>
namespace mmx {

symbol MMX_CLASS ("Class");
symbol MMX_GENERIC ("Generic");
symbol MMX_VOID ("Void");
symbol MMX_BOOL ("Bool");
symbol MMX_INT ("Int");
symbol MMX_STRING ("String");
symbol MMX_OSTREAM ("Ostream");
symbol MMX_ALIAS ("Alias");

generic ID_CLASS= MMX_CLASS;
generic ID_GENERIC= MMX_GENERIC;
generic ID_VOID= list (MMX_CROSS);
generic ID_BOOL= MMX_BOOL;
generic ID_INT= MMX_INT;
generic ID_STRING= MMX_STRING;
generic ID_OSTREAM= MMX_OSTREAM;
generic ID_CROSS= MMX_CROSS;
generic ID_FUNCTION= MMX_FUNCTION;
generic ID_ALIAS= MMX_ALIAS;

value VAL_CLASS (MMX_CLASS, ID_CLASS);
value VAL_GENERIC (MMX_GENERIC, ID_GENERIC);
value VAL_VOID (MMX_VOID, ID_VOID);
value VAL_BOOL (MMX_BOOL, ID_BOOL);
value VAL_INT (MMX_INT, ID_INT);
value VAL_STRING (MMX_STRING, ID_STRING);
value VAL_OSTREAM (MMX_OSTREAM, ID_OSTREAM);
value VAL_CROSS (MMX_CROSS, ID_CROSS);
value VAL_FUNCTION (MMX_FUNCTION, ID_FUNCTION);
value VAL_ALIAS (MMX_ALIAS, ID_ALIAS);

value VAL_NONE= value (generic (), ID_VOID);

symbol CONV_FUNCTION ("0#");
symbol CONV_ARGUMENT ("1#");
symbol CONV_APPLY ("apply#");
symbol CONV_CROSS ("cross#");
symbol CONV_IGNORE ("ignore#");
symbol CONV_LAMBDA ("lambda#");
symbol CONV_UNALIAS ("unalias#");
symbol CONV_UNAND ("unand#");
symbol CONV_UNCROSS ("uncross#");

} // namespace mmx
