
/******************************************************************************
* MODULE     : types.hh
* DESCRIPTION: frequently used type symbols and values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __TYPES_HH
#define __TYPES_HH
#include <symbol.hh>
#include <value.hh>
namespace mmx {

extern symbol MMX_CLASS;
extern symbol MMX_GENERIC;
extern symbol MMX_VOID;
extern symbol MMX_BOOL;
extern symbol MMX_INT;
extern symbol MMX_STRING;
extern symbol MMX_OSTREAM;
extern symbol MMX_ALIAS;

extern generic ID_CLASS;
extern generic ID_GENERIC;
extern generic ID_VOID;
extern generic ID_BOOL;
extern generic ID_INT;
extern generic ID_STRING;
extern generic ID_OSTREAM;
extern generic ID_CROSS;
extern generic ID_FUNCTION;
extern generic ID_ALIAS;

extern value VAL_CLASS;
extern value VAL_GENERIC;
extern value VAL_VOID;
extern value VAL_BOOL;
extern value VAL_INT;
extern value VAL_STRING;
extern value VAL_OSTREAM;
extern value VAL_CROSS;
extern value VAL_FUNCTION;
extern value VAL_ALIAS;

extern value VAL_NONE;

extern symbol CONV_FUNCTION;
extern symbol CONV_ARGUMENT;
extern symbol CONV_APPLY;
extern symbol CONV_CROSS;
extern symbol CONV_IGNORE;
extern symbol CONV_LAMBDA;
extern symbol CONV_UNALIAS;
extern symbol CONV_UNAND;
extern symbol CONV_UNCROSS;

}
#endif // __TYPES_HH
