
/******************************************************************************
* MODULE     : token_symbols.cc
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <token_symbols.hh>
namespace mmx {

symbol MMX_ACCESS (".[]");
symbol MMX_AND ("&&");
symbol MMX_ASSIGN (":=");
symbol MMX_BEGIN ("begin!");
symbol MMX_CASE ("case!");
symbol MMX_COMPOSE ("@");
symbol MMX_CROSS ("Cross"); // added
symbol MMX_DECLARE ("declare!");
symbol MMX_DEFINE ("==");
symbol MMX_DEFINEALIAS (":==");
symbol MMX_DOLLAR ("$");
symbol MMX_DOT (".");
symbol MMX_DOTS ("..");
symbol MMX_ELSE ("else!");
symbol MMX_EQUAL ("=");
symbol MMX_EQUIV ("<=>");
symbol MMX_ERROR ("error!");
symbol MMX_EXISTS ("exists!");
symbol MMX_EXPORT ("export!");
symbol MMX_FACTORIAL (".!");
symbol MMX_FOR ("for!");
symbol MMX_FORALL ("forall!");
symbol MMX_FUNCTION ("->"); // added
symbol MMX_GTR (">");
symbol MMX_GTREQ (">=");
symbol MMX_GTRGTR (">>");
symbol MMX_HAS ("has!");
symbol MMX_HOLDS ("holds!");
symbol MMX_IF ("if!");
symbol MMX_IMPLIES ("=>");
symbol MMX_IMPORT ("import!");
symbol MMX_LAMBDA ("lambda!");
symbol MMX_LESS ("<");
symbol MMX_LESSEQ ("<=");
symbol MMX_LESSLESS ("<<");
symbol MMX_LOCAL ("local!");
symbol MMX_LOOP ("loop!");
symbol MMX_MIGRATE ("migrate!");
symbol MMX_MODIFY ("mod!");
symbol MMX_MINUS ("-");
symbol MMX_MINUSASSIGN ("-=");
symbol MMX_NOT ("!");
symbol MMX_NOTGTR ("!>");
symbol MMX_NOTGTREQ ("!>=");
symbol MMX_NOTLESS ("!<");
symbol MMX_NOTLESSEQ ("!<=");
symbol MMX_NUMBER ("#");
symbol MMX_OMINUS ("@-");
symbol MMX_OOVER ("@/");
symbol MMX_OPLUS ("@+");
symbol MMX_OR ("||");
symbol MMX_OTIMES ("@*");
symbol MMX_OVER ("/");
symbol MMX_OVERASSIGN ("/=");
symbol MMX_PLUS ("+");
symbol MMX_PLUSASSIGN ("+=");
symbol MMX_POSTDEC (".--");
symbol MMX_POSTINC (".++");
symbol MMX_POWER ("^");
symbol MMX_PREDEC ("--");
symbol MMX_PREINC ("++");
symbol MMX_PRIME ("'");
symbol MMX_SEQAND ("and!");
symbol MMX_SEQOR ("or!");
symbol MMX_SQTUPLE ("[]");
symbol MMX_STEP ("step!");
symbol MMX_TIMES ("*");
symbol MMX_TIMESASSIGN ("*=");
symbol MMX_TRANSTYPE (":>");
symbol MMX_TUPLE ("tuple!");
symbol MMX_TYPE (":");
symbol MMX_UNEQUAL ("!=");
symbol MMX_UNTIL ("until!");
symbol MMX_WHILE ("while!");
symbol MMX_XOR ("^^");

} // namespace mmx
